#include "extint.h"
//#include "uart.h"
#include "ps2kbd.h"
#include "scancodes.h"
//#define bit_test(var) ((var & (1<<bit)) != 0)

unsigned char	keyBuf[KBUFFSIZE];	//PS2 Keyboard buffer, the register to store characters key in
uint8_t	keyIn;			//Index into PS/2 key buf where next scan code will be inserted
uint8_t	keyOut;			//Index into PS/2 key buf where next scan code will be removed
uint8_t	keyRead;		//Number of keys read from the PS/2 keyboard
// uint8_t edge;
uint8_t bitcount;       // 0 = neg.  1 = pos.

DWORD cfgKeyboard(void)
{
  IO0CLR = KB_CLK; //hold keyboard clock line untill ready

  EXTMODE = EINT1_EDGE;	/* INT1 edge trigger */
  EXTPOLAR = 0;			/* INT1 is falling edge by default */

  PINSEL0 = (PINSEL0 & ~KBD_PINMASK) | KBD_PINSEL;
  /* initialize the interrupt vector */
  VICIntSelect &= ~VIC_BIT(VIC_EINT1);  // EINT1 selected as IRQ
  VICVectAddr2 = (uint32_t)extISR1;     // address of the ISR
  VICVectCntl2 = VIC_ENABLE | VIC_EINT1;
  VICIntEnable = VIC_BIT(VIC_EINT1);    // EINT1 interrupt enabled

  // edge = 0;
  bitcount = 0;
  keyIn =0;
  keyOut=0;
  keyRead=0;

  EXTINT = EINT1;	/* clear interrupt */


  return(TRUE);
}




void decode(unsigned char sc)
{
  static unsigned char is_up=0, shift = 0;//, mode = 0;
  unsigned char i;

  if (!is_up)                   /* Last data received was the up-key identifier */
    {
      switch (sc)
        {
        case BREAKCHAR :        /*  The up-key identifier */
          is_up = 1;
          break;
        case NONUMCODE :
          //is_up = 1;
          break;
        case LEFTSHIFT :
          shift = 1;
          break;
        case RIGHTSHIFT:
          shift = 1;
          break;
//        case 0x58: //caps lock
//          break;
        default:
          if (!shift)          /* If shift not pressed */
            {
              // do a table look-up
              for (i = 0; unshifted[i][0]!=sc && unshifted[i][0]; i++);
              if (unshifted[i][0] == sc)
                {
                  putkeybuf((unshifted[i][1]));
                }
            }
          else
            {
              /* look-up */
              for (i = 0; shifted[i][0]!=sc && shifted[i][0]; i++);
              if (shifted[i][0] == sc)
                {
                  putkeybuf((shifted[i][1]));
                }
            }
          break;
        }
    }
  else
    {
      is_up = 0;
      switch (sc)
        {
        case LEFTSHIFT :
        case RIGHTSHIFT:
          shift = 0;
          break;
        }
    }
}//decode


void putkeybuf (unsigned char key)
{
  if (keyRead < KBUFFSIZE)  		//make sure that we don't overflow the buffer
    {
      keyRead++;							//Increment the number of keys read
      keyBuf[keyIn++] = key;		//Store the scan code into the buffer
      if (keyIn >= KBUFFSIZE)  	//Adjust index to the next scan code to put in buffer
        {
          keyIn = 0;
        }
    }
}


uint8_t keyhit(void)
{
  unsigned char hit;
  hit = (unsigned char)(keyRead > 0)? TRUE : FALSE;
  return(hit);
}

unsigned char xgetkey (void)
{
  unsigned char key=0;
  if (keyRead > 0)
    {
      keyRead--;			/* Decrement the number of keys in the buffer */
      key = keyBuf[keyOut];	/* Get scan code from the buffer */
      keyOut++;
      if (keyOut >= KBUFFSIZE)
        {
          keyOut = 0;
        }

    }// else {
  //	return (0xFF);					/* No scan codes in buffer, return -1 */
  //}
  return (key);						/* return the scan code of the key pressed */
}

//  void SendByte(BYTE b)
//  {

//  }




